accounts/urls.py
from django.urls import path
from accounts.views import user_login, user_logout, user_signup

urlpatterns = [
    path("login/", user_login, name="login"),
    path("logout/", user_logout, name="logout"),
    path("signup/", user_signup, name="signup"),
]

projects/urls.py
from django.urls import path
from projects.views import list_projects, show_project, create_project

urlpatterns = [
    path("<int:id>/", show_project, name="show_project"),
    path("", list_projects, name="list_projects"),
    path("create/", create_project, name="create_project"),
]

tasks/urls.py
from django.urls import path
from tasks.views import create_task, show_my_tasks

urlpatterns = [
    path("create/", create_task, name="create_task"),
    path("mine/", show_my_tasks, name="show_my_tasks"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect


def redirect_to_home(request):
    return redirect("list_projects")


urlpatterns = [
    path("accounts/", include("accounts.urls")),
    path("", redirect_to_home, name="home"),
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path("tasks/", include("tasks.urls")),
]

projects/models.py
from django.db import models
from django.conf import settings


class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    owner = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        related_name="projects",
        on_delete=models.CASCADE,
        null=True,
    )

    def __str__(self):
        return self.name


# Create your models here.

tasks/models.py
from django.db import models
from projects.models import Project
from django.conf import settings


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField(null=False, blank=False)
    due_date = models.DateTimeField(null=False, blank=False)
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        Project,
        related_name="tasks",
        on_delete=models.CASCADE,
    )
    assignee = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        related_name="tasks",
        on_delete=models.CASCADE,
        null=True,
    )


# Create your models here.

accounts/forms.py
from django import forms


class LoginForm(forms.Form):
    username = forms.CharField(max_length=150)
    password = forms.CharField(
        max_length=150,
        widget=forms.PasswordInput(),
    )


class SignupForm(forms.Form):
    username = forms.CharField(max_length=150, initial="")
    password = forms.CharField(
        max_length=150, widget=forms.PasswordInput(), initial=""
    )
    password_confirmation = forms.CharField(
        max_length=150, widget=forms.PasswordInput(), initial=""
    )

projects/forms.py
from django import forms
from projects.models import Project


class ProjectForm(forms.ModelForm):
    class Meta:
        model = Project
        fields = [
            "name",
            "description",
            "owner",
        ]

tasks/forms.py
from django import forms
from tasks.models import Task


class TaskForm(forms.ModelForm):
    class Meta:
        model = Task
        fields = [
            "name",
            "start_date",
            "due_date",
            "project",
            "assignee",
        ]

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth import authenticate, login, logout
from accounts.forms import LoginForm, SignupForm
from django.contrib.auth.models import User
from django.contrib import messages


def user_login(request):
    if request.method == "POST":
        form = LoginForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data["username"]
            password = form.cleaned_data["password"]
            user = authenticate(request, username=username, password=password)
            if user is not None:
                login(request, user)
                return redirect("list_projects")
            else:
                messages.error(request, "Invalid username or password.")
    else:
        form = LoginForm()

    context = {
        "form": form,
    }
    return render(request, "accounts/login.html", context)


def user_logout(request):
    logout(request)
    return redirect("login")


def user_signup(request):
    if request.method == "POST":
        form = SignupForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data["username"]
            password = form.cleaned_data["password"]
            confirm = form.cleaned_data["password_confirmation"]

            if password == confirm:
                if User.objects.filter(username=username).exists():
                    form.add_error(
                        "username", "A user with that username already exists."
                    )
                else:
                    user = User.objects.create_user(
                        username, password=password
                    )
                    login(request, user)
                    return redirect("list_projects")
            else:
                form.add_error(
                    "password_confirmation", "The passwords do not match"
                )
    else:
        form = SignupForm()

    context = {
        "form": form,
    }
    return render(request, "accounts/signup.html", context)


# Create your views here.

projects/views.py
from django.shortcuts import render, redirect, get_object_or_404
from projects.models import Project
from django.contrib.auth.decorators import login_required
from projects.forms import ProjectForm


@login_required
def list_projects(request):
    projects = Project.objects.filter(owner=request.user)
    context = {
        "projects": projects,
    }
    return render(request, "projects/list.html", context)


@login_required
def show_project(request, id):
    project = get_object_or_404(Project, id=id)
    context = {
        "project": project,
    }
    return render(request, "projects/details.html", context)


@login_required
def create_project(request):
    if request.method == "POST":
        form = ProjectForm(request.POST)
        if form.is_valid():
            project = form.save(False)
            project.save()
            return redirect("list_projects")
    else:
        form = ProjectForm()
    context = {
        "form": form,
    }
    return render(request, "projects/create.html", context)


# Create your views here.

tasks/views.py
from django.shortcuts import render, redirect
from tasks.forms import TaskForm
from django.contrib.auth.decorators import login_required
from tasks.models import Task


@login_required
def create_task(request):
    context = {}  # Define context variable outside the if statement
    
    if request.method == "POST":
        form = TaskForm(request.POST)
        if form.is_valid():
            project = form.save()
            project.save()
            return redirect("list_projects")
    else:
        form = TaskForm()
        context = {
            "form": form,
        }
    
    return render(request, "tasks/create.html", context)


@login_required
def show_my_tasks(request):
    tasks = Task.objects.filter(assignee=request.user)
    context = {
        "tasks": tasks,
    }
    return render(request, "tasks/list.html", context)


# Create your views here.

accounts/templates/accounts/login.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List of Receipts</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">
    <style>
        body {
            background-color: #f4f5f8;
        }

        .navbar {
            background-color: #90f6c3;
        }

        .container {
            display: flex;
            justify-content: center;
            align-items: center;
            height: 90vh;
        }

        form {
            max-width: 600px;
            padding: 40px;
            background-color: #90f6c3;
            border: 5px;
        }

        .form-group {
            margin-bottom: 20px;
        }

        label {
            display: block;
            font-weight: bold;
            margin-bottom: 10px;
        }

        input[type="text"],
        input[type="password"] {
            width: 100%;
            padding: 12px;
            border: 1px solid #ccc;
            border-radius: 4px;
        }

        button[type="submit"] {
            width: 100%;
            padding: 12px;
            background-color: #7f20d8;
            color: #FFFFFF;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        .signup-link {
            text-align: center;
            margin-top: 10px;
        }
        .title {
            text-align: center;
            color: #8320ed;
        }
    </style>
</head>

<body>
    <header class="navbar">
        <nav class="navbar navbar-expand-lg">
            <div class="container-fluid">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="{% url 'login' %}">Login</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'signup' %}">Signup</a>
                    </li>
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'show_my_tasks' %}">My tasks</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'list_projects' %}">My projects</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                    </li>
                    {% endif %}
                </ul>
            </div>
        </nav>
    </header>
    <h1 class="title">ProjectUno</h1>
    <div class="container">
        {% block content %}
        <main>
            <form method="post">
                {% csrf_token %}
                <h1>Login</h1>
                {% if messages %}
                <ul class="messages">
                    {% for message in messages %}
                    <li{% if message.tags %} class="{{ message.tags }}" {% endif %}>{{ message }}</li>
                    {% endfor %}
                </ul>
                {% endif %}
                <div class="form-group">
                    <label for="username">Username</label>
                    <input type="text" id="username" name="username" required>
                </div>
                <div class="form-group">
                    <label for="password">Password</label>
                    <input type="password" id="password" name="password" required>
                </div>
                <button type="submit">Login</button>
                <div class="signup-link">
                    <p>Don't Have an Account?</p>
                    <a class="btn btn-link" href="{% url 'signup' %}">Signup</a>
                </div>
            </form>
        </main>
        {% endblock content %}
    </div>
</body>

</html>

accounts/templates/accounts/signup.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Project-Uno</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">
    <style>
        body {
            background-color: #f4f5f8;
        }

        .container {
            display: flex;
            justify-content: center;
            align-items: center;
            height: 90vh;
        }

        form {
            max-width: 600px;
            padding: 40px;
            background-color: #90f6c3;
            border-radius: 5px;
        }

        .form-group {
            margin-bottom: 15px;
        }

        label {
            display: block;
            font-weight: bold;
            margin-bottom: 5px;
        }

        input[type="text"],
        input[type="password"] {
            width: 100%;
            padding: 10px;
            border: 1px solid #ccc;
            border-radius: 4px;
        }

        button[type="submit"] {
            width: 100%;
            padding: 10px;
            background-color: #7f20d8;
            color: #FFFFFF;
            border: none;
            border-radius: 4px;
            cursor: pointer;
        }

        .signup-link {
            text-align: center;
            margin-top: 10px;
        }

        .welcome-message {
            text-align: center;
        }
        .title {
            text-align: center;
            color: #8320ed;
        }
    </style>
</head>

<body>
    <header>
        <nav class="navbar navbar-expand-lg" style="background-color: #90f6c3;">
            <div class="container-fluid">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="{% url 'login' %}">Login</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'signup' %}">Signup</a>
                    </li>
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'show_my_tasks' %}">My tasks</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'list_projects' %}">My projects</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                    </li>
                    {% endif %}
                </ul>
            </div>
        </nav>
    </header>

    <h1 class="title">Project-Uno</h1>
    <h4 class="welcome-message">Welcome To Project-Uno! A Project and Task management application for Software
        Developers to organize their tasks.</h4>

    <main>
        <div class="container">
            <form method="post">
                {% csrf_token %}
                <h1>Signup</h1>
                <div class="form-group">
                    <label for="id_username">Username</label>
                    <input type="text" id="username" name="username" class="form-control" required
                        value="{{ form.username.value }}">
                    {% if form.errors.username %}
                    <div class="error">{{ form.errors.username }}</div>
                    {% endif %}
                </div>
                <div class="form-group">
                    <label for="id_password">Password</label>
                    <input type="password" id="password" name="password" class="form-control" required
                        value="{{ form.password.value }}">
                    {% if form.errors.password %}
                    <div class="error">{{ form.errors.password }}</div>
                    {% endif %}
                </div>
                <div class="form-group">
                    <label for="id_password_confirmation">Confirm Password</label>
                    <input type="password" id="password_confirmation" name="password_confirmation" class="form-control"
                        required value="{{ form.password_confirmation.value }}">
                    {% if form.errors.password_confirmation %}
                    <div class="error">{{ form.errors.password_confirmation }}</div>
                    {% endif %}
                </div>
                <button type="submit" class="btn" style="background-color: #7f20d8; color: #FFFFFF;">Signup</button>
            </form>
        </div>
    </main>

</body>

</html>

projects/templates/projects/create.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List of Receipts</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">
</head>

<body>
    <header>
        <nav class="navbar navbar-expand-lg" style="background-color: #90f6c3;">
            <div class="container-fluid">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'show_my_tasks' %}">My tasks</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'list_projects' %}">My projects</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                    </li>
                    {% else %}
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="{% url 'login' %}">Login</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'signup' %}">Signup</a>
                    </li>
                    {% endif %}
                </ul>
            </div>
        </nav>
    </header>
    {% block content %}
    <main>
        <div>
            <h1>Create New Project</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Create</button>
            </form>
        </div>
    </main>
    {% endblock content %}
</body>

</html>

projects/templates/projects/details.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">
    <title>Tasks</title>
</head>

<body>
    <header>
        <nav class="navbar navbar-expand-lg" style="background-color: #90f6c3;">
            <div class="container-fluid">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'show_my_tasks' %}">My tasks</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'list_projects' %}">My projects</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                    </li>
                    {% else %}
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="{% url 'login' %}">Login</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'signup' %}">Signup</a>
                    </li>
                    {% endif %}
                </ul>
            </div>
        </nav>
    </header>
    {% block content %}
    <main>
        <div>
            <h1> {{ project.name }} </h1>
            <p> {{ project.description }} </p>
            <h2>Tasks</h2>
            <a href="{% url 'create_task' %}">Create a new task</a>
            {% if project.tasks.exists %}
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Assignee</th>
                        <th>Start date</th>
                        <th>Due date</th>
                        <th>Is completed</th>
                    </tr>
                </thead>
                <tbody>
                    {% for task in project.tasks.all %}
                    <tr>
                        <td>{{ task.name }}</td>
                        <td>{{ task.assignee }}</td>
                        <td>{{ task.start_date|date:"M d, Y" }}</td>
                        <td>{{ task.due_date|date:"M d, Y" }}</td>
                        <td>{{ task.is_completed|yesno }}</td>
                    </tr>
                    {% endfor %}
                </tbody>
            </table>
            {% else %}
            <p>This project has no tasks</p>
            {% endif %}
        </div>
    </main>
    {% endblock content %}
</body>

</html>

projects/templates/projects/list.html
<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">
    <title>ProjectUno</title>
</head>

<body>
    <header>
        <nav class="navbar navbar-expand-lg" style="background-color: #90f6c3;">
            <div class="container-fluid">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'show_my_tasks' %}">My tasks</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'list_projects' %}">My projects</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                    </li>
                    {% else %}
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="{% url 'login' %}">Login</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'signup' %}">Signup</a>
                    </li>
                    {% endif %}
                </ul>
            </div>
        </nav>
    </header>
    {% block content %}
    <main>
        <div>
            <h1>My Projects</h1>
            <p>
                <a href="{% url 'create_project' %}">Create New Project</a>
            </p>
            {% if projects.exists %}
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Number of tasks</th>
                    </tr>
                </thead>
                <tbody>
                    {% for project in projects %}
                    <tr>
                        <td>
                            <a href="{% url 'show_project' project.id %}">{{ project.name }}</a>
                        </td>
                        <td>{{ project.tasks.all|length }}</td>
                    </tr>
                    {% endfor %}
                </tbody>
            </table>
            {% else %}
            <p>You are not assigned to any projects</p>
            {% endif %}
        </div>
    </main>
    {% endblock content %}
</body>

</html>

tasks/templates/tasks/create.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>List of Receipts</title>
</head>

<body>
    <header>
        <nav>
            <ul>
                {% if user.is_authenticated %}
                <li>
                    <a href="{% url 'show_my_tasks' %}">My tasks</a>
                </li>
                <li>
                    <a href="{% url 'list_projects' %}">My projects</a>
                </li>
                <li>
                    <a href="{% url 'logout' %}">Logout</a>
                </li>
                {% else %}
                <li>
                    <a href="{% url 'login' %}">Login</a>
                </li>
                <li>
                    <a href="{% url 'signup' %}">Signup</a>
                </li>
                {% endif %}
            </ul>
        </nav>
    </header>
    {% block content %}
    <main>
        <div>
            <h1>Create a new task</h1>
            <form method="post">
                {% csrf_token %}
                {{ form.as_p }}
                <button>Create</button>
            </form>
        </div>

    </main>
    {% endblock content %}
</body>

</html>

tasks/templates/tasks/list.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-9ndCyUaIbzAi2FUVXJi0CjmCapSmO7SnpJef0486qhLnuZ2cdeRhO02iuK6FUUVM" crossorigin="anonymous">
    <title>ProjectUno</title>
</head>

<body>
    <header>
        <nav class="navbar navbar-expand-lg" style="background-color: #90f6c3;">
            <div class="container-fluid">
                <ul class="navbar-nav me-auto mb-2 mb-lg-0">
                    {% if user.is_authenticated %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'show_my_tasks' %}">My tasks</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'list_projects' %}">My projects</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                    </li>
                    {% else %}
                    <li class="nav-item">
                        <a class="nav-link active" aria-current="page" href="{% url 'login' %}">Login</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'signup' %}">Signup</a>
                    </li>
                    {% endif %}
                </ul>
            </div>
        </nav>
    </header>
    {% block content %}
    <main>
        <div>
            <h1>My Tasks</h1>
            {% if tasks.exists %}
            <table>
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Start date</th>
                        <th>Due date</th>
                        <th>Is completed</th>
                    </tr>
                <tbody>
                    {% for task in tasks.all %}
                    <tr>
                        <td>{{ task.name }}</td>
                        <td>{{ task.start_date|date:"M d, Y" }}</td>
                        <td>{{ task.due_date|date:"M d, Y" }}</td>
                        <td>{{ task.is_completed|yesno }}</td>
                    </tr>
                    {% endfor %}
                </tbody>
                </thead>
            </table>
            {% else %}
            <p>You have no tasks</p>
            {% endif %}
        </div>
    </main>
    {% endblock content %}
</body>

</html>